<?php
/**
 * Created by JetBrains PhpStorm.
 * User: kdemanuele
 * Date: 10/15/13
 * Time: 8:26 PM
 * To change this template use File | Settings | File Templates.
 */
class Clounce_VisibilityByStore_Model_Observer {
    public function setAttributeForm(Varien_Event_Observer $observer) {
        $form = $observer->getEvent()->getForm();
        $fieldset = $form->getElement('front_fieldset');
        $storegroups = array_merge(array(array('value'=>'none', 'label'=>Mage::helper('clounce_visibilitybystore')->__('No Exclusions'))),
            Mage::getModel('core/store_group')->getCollection()->toOptionArray());

        $fieldset->addField('store_visibility', 'multiselect', array(
            'name'  => 'store_visibility',
            'label' => Mage::helper('catalog')->__('Exclude visibility from stores'),
            'title' => Mage::helper('catalog')->__('Exclude visibility from stores'),
            'note'  => Mage::helper('catalog')->__('Hold the Ctrl key for multiple selection.<br/>Use "No Exclusions" to remove rule from all stores.'),
            'values'=> $storegroups
        ), 'is_visible_on_front');
    }

    public function saveAttributeVisibility(Varien_Event_Observer $observer) {
        $data = $observer->getEvent()->getDataObject();
        $storeVisibility = $data->getStoreVisibility();
        if (!empty($storeVisibility)) {
            try {
                $model = Mage::getResourceModel('clounce_visibilitybystore/productStoreVisibility_collection')
                    ->addFilter('attribute_code', $data->getAttributeCode())
                    ->getFirstItem();

                if (in_array('none', $storeVisibility)) {
                    if ($model->getId()) {
                        $model->delete();
                    }
                } else {
                    if (!$model->getId()) {
                        $model->setAttributeCode($data->getAttributeCode());
                    }

                    $model->setStore(implode(',', $data->getStoreVisibility()));

                    $model->save();
                }
            } catch (Exception $e) {
                Mage::log($e->getMessage(), null, 'storevisibility.log');
            }
        }
    }

    public function loadAttributeVisibility(Varien_Event_Observer $observer) {
        $data = $observer->getEvent()->getDataObject();
        try {
            $model = Mage::getResourceModel('clounce_visibilitybystore/productStoreVisibility_collection')
                ->addFilter('attribute_code', $data->getAttributeCode())
                ->getFirstItem();

            if ($model->getId()) {
                $data->setStoreVisibility(explode(',', $model->getStore()));
            }

        } catch (Exception $e) {
            Mage::log($e->getMessage(), null, 'storevisibility.log');
        }
    }
}